/* Tabela IMPRESSORA: TABELA DE IMPRESSORA */
/* Descrio: A trigger insere registros na tabela LOGOPERAVND a partir de alteraes na tabela IMPRESSORA*/
/* Objetivo: Gerar um log que vai registrar as alteraes na IMPRESSORA,
             utilizando a tabela de Logs de Operaes do VND*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_VND_IMPRESSORA' AND
                 TYPE   = 'TR' 	               AND
	              U.UID  = O.UID           AND
	              U.NAME = USER)
DROP TRIGGER LOG_VND_IMPRESSORA
GO


CREATE TRIGGER LOG_VND_IMPRESSORA
ON IMPRESSORA
FOR INSERT, UPDATE, DELETE
AS
  DECLARE @V_DSREMOTEADDR VARCHAR(15);
  DECLARE @V_DSREMOTEHOST VARCHAR(15);
  DECLARE @V_DSSERVERRDM  VARCHAR(20);
  DECLARE @V_DSSERVMETHOD VARCHAR(30);
  DECLARE @V_DSREMOTEOPER VARCHAR(12);
  DECLARE @V_DESC         VARCHAR(500);
  DECLARE @V_ITPESQ       VARCHAR(40);
  DECLARE @V_NMOPERADOR   VARCHAR(40);
  DECLARE @V_IDTIPOOPER   VARCHAR(1);

/*VARIVEIS DO CURSOR C_CURSOR*/

  DECLARE @V_ID_COMANDO    VARCHAR(1);

  DECLARE @V_NEW_CDIMPRESSORA          VARCHAR(3);                 
  DECLARE @V_NEW_NMIMPRESSORA          VARCHAR(50);                 
  DECLARE @V_NEW_IDTIPOIMPRES          VARCHAR(1);                 
  DECLARE @V_NEW_IDMODEIMPRES          VARCHAR(3);                 
  DECLARE @V_NEW_DTULTATUIMPR          Date;                                                                                                                               

  DECLARE @V_OLD_CDIMPRESSORA          VARCHAR(3);                 
  DECLARE @V_OLD_NMIMPRESSORA          VARCHAR(50);                 
  DECLARE @V_OLD_IDTIPOIMPRES          VARCHAR(1);                 
  DECLARE @V_OLD_IDMODEIMPRES          VARCHAR(3);                 
  DECLARE @V_OLD_DTULTATUIMPR          Date;                                                                                                                   


BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   SET @V_DESC   = '';
   SET @V_ITPESQ     = '';
   SET @V_NMOPERADOR = '';
   SET @V_IDTIPOOPER = '';

   EXEC NMUSUARIO @P_NMUSUARIO = @V_NMOPERADOR OUTPUT;
   SET @V_NMOPERADOR = ISNULL(@V_NMOPERADOR, ' ');

   EXEC WEBTUNNING  @P_DSREMOTEADDR = @V_DSREMOTEADDR OUTPUT,
                    @P_DSREMOTEHOST = @V_DSREMOTEHOST OUTPUT,
                    @P_DSSERVERRDM  = @V_DSSERVERRDM OUTPUT,
                    @P_DSSERVMETHOD = @V_DSSERVMETHOD OUTPUT,
                    @P_DSREMOTEOPER = @V_DSREMOTEOPER OUTPUT;

   DECLARE C_CURSOR CURSOR FOR
     SELECT
     'D'   ID_COMANDO,
           NULL,NULL,NULL,
           NULL,NULL,
           DELETED.CDIMPRESSORA,
           DELETED.NMIMPRESSORA,
           DELETED.IDTIPOIMPRES,
           DELETED.IDMODEIMPRES,
           DELETED.DTULTATUIMPR

     FROM
           DELETED
     WHERE     
           DELETED.CDIMPRESSORA   NOT IN (SELECT CDIMPRESSORA FROM INSERTED)
     UNION ALL

     SELECT
     'U'   IDCOMANDO,
           INSERTED.CDIMPRESSORA,
           INSERTED.NMIMPRESSORA,
           INSERTED.IDTIPOIMPRES,
           INSERTED.IDMODEIMPRES,
           INSERTED.DTULTATUIMPR,


           DELETED.CDIMPRESSORA,
           DELETED.NMIMPRESSORA,
           DELETED.IDTIPOIMPRES,
           DELETED.IDMODEIMPRES,
           DELETED.DTULTATUIMPR

     FROM
           INSERTED,
           DELETED
     WHERE     
	   INSERTED.CDIMPRESSORA = DELETED.CDIMPRESSORA
     UNION ALL

     SELECT
     'I'   IDCOMANDO,
           INSERTED.CDIMPRESSORA,
           INSERTED.NMIMPRESSORA,
           INSERTED.IDTIPOIMPRES,
           INSERTED.IDMODEIMPRES,
           INSERTED.DTULTATUIMPR,
           NULL,NULL,NULL,
           NULL,NULL
     FROM
           INSERTED
     WHERE     
           INSERTED.CDIMPRESSORA NOT IN (SELECT CDIMPRESSORA FROM DELETED)

     OPEN C_CURSOR;
     FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
				   @V_NEW_CDIMPRESSORA,@V_NEW_NMIMPRESSORA,@V_NEW_IDTIPOIMPRES,@V_NEW_IDMODEIMPRES,
				   @V_NEW_DTULTATUIMPR, 				 



				   @V_OLD_CDIMPRESSORA,@V_OLD_NMIMPRESSORA,@V_OLD_IDTIPOIMPRES,@V_OLD_IDMODEIMPRES,
				   @V_OLD_DTULTATUIMPR
				   


    WHILE (@@FETCH_STATUS = 0) BEGIN
    
       IF @V_ID_COMANDO= 'U' /*UPDATE*/ BEGIN
		IF ISNULL(@V_NEW_CDIMPRESSORA,'NULL') <> ISNULL(@V_OLD_CDIMPRESSORA,'NULL') BEGIN
			SET @V_DESC  = 'Cd Impressora '               + ISNULL(@V_NEW_CDIMPRESSORA,''    );
		END;
		IF ISNULL(@V_NEW_NMIMPRESSORA,'NULL') <> ISNULL(@V_OLD_NMIMPRESSORA,'NULL') BEGIN
            SET @V_DESC  = ISNULL(@V_DESC,'') + '  Nm Impressora  '                + ISNULL(@V_NEW_NMIMPRESSORA,''  );
		END;
		IF ISNULL(@V_NEW_IDTIPOIMPRES,'NULL') <> ISNULL(@V_OLD_IDTIPOIMPRES,'NULL') BEGIN
            SET @V_DESC  = ISNULL(@V_DESC,'') + '  Id Tipo Impressora  '                + ISNULL(@V_NEW_IDTIPOIMPRES,''  );
		END;
		IF ISNULL(@V_NEW_IDMODEIMPRES,'NULL') <> ISNULL(@V_OLD_IDMODEIMPRES,'NULL') BEGIN
            SET @V_DESC  = ISNULL(@V_DESC,'') + '  Id Modo Impressora  '                + ISNULL(@V_NEW_IDMODEIMPRES,''  );
		END;
		IF ISNULL(CONVERT(VARCHAR,@V_NEW_DTULTATUIMPR),'NULL') <> ISNULL(CONVERT(VARCHAR,@V_OLD_DTULTATUIMPR),'NULL') BEGIN
            SET @V_DESC  = ISNULL(@V_DESC,'') + '  Data Ult Atualizao Impressora '  + ISNULL(CONVERT(VARCHAR,@V_NEW_DTULTATUIMPR),'');
		END;

          SET @V_IDTIPOOPER = '2';
       END;

       IF @V_ID_COMANDO= 'I' /*INSERO*/ BEGIN
          SET @V_DESC  = 'Cd Impressora '               + ISNULL(@V_NEW_CDIMPRESSORA,''    )    +  ' '  + 
                  'Nm Impressora  '                + ISNULL(@V_NEW_NMIMPRESSORA,''  )        +  ' '  + 
                  'Id Tipo Impressora '              + ISNULL(@V_NEW_IDTIPOIMPRES,'' )      +  ' '  + 
                  'Id Modo Impressora  '      + ISNULL(@V_NEW_IDMODEIMPRES,'' )   +  ' '  + 
                  'Data Ult Atualizao Impressora  '       + ISNULL(CONVERT(VARCHAR,@V_NEW_DTULTATUIMPR),''  );

          SET @V_IDTIPOOPER = '1';
       END;
       IF @V_ID_COMANDO= 'D' /*DELEO*/  BEGIN

          SET @V_DESC  = 'Cd Impressora '               + ISNULL(@V_OLD_CDIMPRESSORA,''    )    +  ' '  + 
                  'Nm Impressora  '                + ISNULL(@V_OLD_NMIMPRESSORA,''  )        +  ' '  + 
                  'Id Tipo Impressora '              + ISNULL(@V_OLD_IDTIPOIMPRES,'' )      +  ' '  + 
                  'Id Modo Impressora  '      + ISNULL(@V_OLD_IDMODEIMPRES,'' )   +  ' '  + 
                  'Data Ult Atualizao Impressora  '       + ISNULL(CONVERT(VARCHAR,@V_OLD_DTULTATUIMPR),''  );

          SET @V_IDTIPOOPER = '3';
       END;

       IF  (@V_IDTIPOOPER <> '') BEGIN
          IF @V_DESC IS NOT NULL BEGIN
             SET @V_ITPESQ =  ISNULL(@V_NEW_CDIMPRESSORA, @V_OLD_CDIMPRESSORA);
             SET @V_DESC = SUBSTRING(@V_DESC, 1, 300);
             INSERT INTO LOGOPERAVND
                     (NMTABELAVND, DTOPERACAOVND, NMRESPOPERVND, IDTIPOOPERVND, DSOPERACAOVND,
                     CDPESQITEMVND, DSRDMUSUOPERVND, DSENDUSUOPERVND, DSNMUSUOPERVND, DSMETUSUOPERVND,
                     CDORESPOPERVND, CDFILLOGOPERVND)
             VALUES ('IMPRESSORA',GETDATE(), ISNULL(@V_NMOPERADOR,' '), @V_IDTIPOOPER, @V_DESC, @V_ITPESQ,
                     @V_DSSERVERRDM, @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVMETHOD, @V_DSREMOTEOPER,
                     '');
          END;
       END;

       FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
				     @V_NEW_CDIMPRESSORA,@V_NEW_NMIMPRESSORA,@V_NEW_IDTIPOIMPRES,@V_NEW_IDMODEIMPRES,
				     @V_NEW_DTULTATUIMPR,

				     @V_OLD_CDIMPRESSORA,@V_OLD_NMIMPRESSORA,@V_OLD_IDTIPOIMPRES,@V_OLD_IDMODEIMPRES,
				     @V_OLD_DTULTATUIMPR


   SET @V_DESC   = '';
   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_VND_IMPRESSORA','5.20.001';
GO










             
