var Cus00104_CustoPlanejadoDoCardapioPorDietaController = function (ScreenService, General, GeneralServices) {
	
	this.defaultValues = function(widget) {
		if (!widget.currentRow.CDFILIAL) {
			widget.newRow();
		}

		GeneralServices.retornaTipoCustoPadrao().then(function(callback) {
			if(callback.dataset.defaulttipocusto[0]) {
				widget.currentRow.NMTIPOCUSTO = callback.dataset.defaulttipocusto[0].NMTIPOCUSTO;
				widget.currentRow.CDTIPOCUSTO = callback.dataset.defaulttipocusto[0].CDTIPOCUSTO;
			}
		});
	};	

	this.validacaoData = function (currentRow) {
		let dataInicial = currentRow.DTINICIAL ? moment(currentRow.DTINICIAL, 'DD/MM/YYYY')._d : null;
		let dataFinal = currentRow.DTFINAL ? moment(currentRow.DTFINAL, 'DD/MM/YYYY')._d : null;
		let mensagem = "A data final deve ser menor ou igual a data final.";

        if (dataInicial && dataFinal && dataFinal < dataInicial) {
            ScreenService.showMessage(mensagem);
            return false;
        }
        return true;
	};

	this.atualizaListaDeServico = function(widget) {
		let grupoServicos = '';
		let currentRow = widget.currentRow;

		if(currentRow.ALLGRUPSERV == 'N') {
			if (currentRow.CDGRUPSERV.length) {
				grupoServicos = currentRow.CDGRUPSERV.join('_');				
			} else {
				grupoServicos = '';
			}
		} else {
			grupoServicos = 'T';
		} 
		General.onClickDependentField(widget.getField('CDSERVFILI'), {CDFILIAL: currentRow.CDFILIAL, CDGRUPSERV: grupoServicos});
	};

	this.atualizaListaDieta = function(currentRow) {
		let arrayConcatDieta = '';

		if(currentRow.TCDIETPAD === 'x') {
			if (currentRow.CDDIETPAD.length) {
				arrayConcatDieta = currentRow.CDDIETPAD.join('_');
				currentRow.TCDIETPAD = 'x';
			} else {
				arrayConcatDieta = '';
			}
		} else {
			arrayConcatDieta = 'x';
			currentRow.TCDIETPAD = 'T';
		}

		currentRow.LISTADIETA = arrayConcatDieta;
	};

	this.verificaCheckboxTodos = function(widget) {
		let currentRow = widget.currentRow;

		if (currentRow.ALLGRUPSERV == 'N' && currentRow.ALLSERVFILI == 'N') {
			currentRow.LISTAGRUPSERV = currentRow.CDGRUPSERV.join('_');
			currentRow.LISTASERV = currentRow.CDSERVFILI.join('_');
		} else if (currentRow.ALLGRUPSERV == 'S' && currentRow.ALLSERVFILI == 'N') {
			currentRow.LISTAGRUPSERV = 'T';
			currentRow.LISTASERV = currentRow.CDSERVFILI.join('_');
		} else if (currentRow.ALLGRUPSERV == 'N' && currentRow.ALLSERVFILI == 'S') {
			currentRow.LISTAGRUPSERV = currentRow.CDGRUPSERV.join('_');
			currentRow.LISTASERV = 'T';
		} else if (currentRow.ALLGRUPSERV == 'S' && currentRow.ALLSERVFILI == 'S') {
			currentRow.LISTAGRUPSERV = 'T';
			currentRow.LISTASERV = 'T';
		}
	};

	this.validacaoCampos = function(widget, row, currentRow) {
		let reportName = currentRow.CD_REPORT_NAME; 
		let reportFormats = [
			{
				name: "pdf",
				value: "PDF"
			},
			{
				name: "xlsx",
				value: "XLSX"
			}
		];

		if(widget.isValid()) {
			General.openReportPopup(widget, this.abreRelatorio, [widget, row, reportName], reportFormats);
		}
	};

	this.abreRelatorio = function(widget, row, reportName) {
		let currentRow = widget.currentRow;	
		this.verificaCheckboxTodos(widget);
		this.atualizaListaDieta(currentRow);
		
		General.openReport('cus_relatorio#/cus00104_custo_planejado_do_cardapio_por_dieta', reportName , row);
	}.bind(this);
	
	this.exportDateValues = function(field){
		if(field.value()){
			field.widget.currentRow.DTINICIAL = field.value().start || '';
			field.widget.currentRow.DTFINAL = field.value().end || ''; 
		}
	};
};

Configuration(function(ContextRegister) {
	ContextRegister.register('Cus00104_CustoPlanejadoDoCardapioPorDietaController', Cus00104_CustoPlanejadoDoCardapioPorDietaController);
});